<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
    <HEAD>
        <TITLE>lsync test</TITLE>
    </HEAD>

    <BODY>
        <H1 align="center">lsync test</H1>

        <H2>Test Objectives</H2>
		<UL>
        <li>Verify lsync.tcl and its shared objects can generate same frame cache content given the same mount points
        as diskcacheAPI. 
        </li><p>
		</UL>
		
		<H2>This is a standalone test, no APIs are affected by this test but the diskcacheAPI is used for cache comparison</H2>
        The test does the following:<p>
        <ol>
        <li>Untar the lsync tar ball in the local directory, or if a directory is specified, cd to that directory.</li>
        <li>cd to the directory created by the untar process</li>
        <li>Updates lsync.rsc with the ::MOUNT_PT variable from diskcacheAPI. </li>
        <li>Invokes lsync.tcl to generate a cache file lsync.cache. </li>
        <li> Compares current diskcacheAPI frame cache to lsync.cache; the test passes if the directories are the same.</li>
        </ol>
				
        <H2>Setup</H2>
        <ul>
        <li><a href='http://www.ldas-dev.ligo.caltech.edu/ldas_outgoing/nightly_tarballs'>Download an lsync tarball</a> to be tested to a 
        directory on the machine that the diskcacheAPI resides or login to the diskcacheAPI machine if the tarball is visible there. </li>
        <li>Install the following tests script: 
		<UL><p>
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/lsync.test?rev=HEAD;content-type=text%2Fplain'>lsync.test</a></font></li>
		</UL>
        </li><p>
        <li>Make sure the mount points are accessible.</li>
        <li>Make sure the frame cache is current by forcing a frame cache rebuild via cmonClient <i>Utilities</i>
        <a href='http://www.ldas-sw.ligo.caltech.edu/doc/userAPI/html/cmonClient-control.html#LDASUtilities'>Rebuild frame disk cache</a></li>
        </ul>
        
        <H2>Test Execution</H2>
        <p>On the diskcacheAPI host 
        <p>Make sure there are no jobs running that would generate frame files as output.
		<p>cd &lt;your directory containing script &gt;<p>
		
        <B>Usage:</B> <CODE> </CODE>

        <P><TABLE border=1 cellspacing=0 cellpadding=10>
            <TR>
                <TH><B>Option</B>
                <TH><B>Description</B>
			<TR>
                <TD valign=top><CODE>&lt;tarball file path or directory containing lsync files&gt;</CODE>
                <TD>supply a tarball path or a directory containing lsync files and objects
        </TABLE><p>
        e.g. with tarball path<pre><font color='brown'>
            lsync.test /ldas_outgoing/nightly_tarballs/lsync-SunOS-sun4u-1.2.39.tar.gz >& lsynctest.log &
            </font></pre>
        or with a specified directory <pre><font color='brown'>
            lsync.test lsync-SunOS-sun4u-1.2.36 >& lsynctest.log &
            </font></pre>
		<p>
		<H2>Test Validation:</H2>
        <ul>
        <li>Verify that there are no errors with lsync.tcl run from the log file <i>lsync.out</i> in lsync files and objects directory.</li>
        <li>Verify that the test passes because there are not difference in cache directories.</li>
        <p>Example of output of an lsync.test that passes:
        <pre><font color='green'>
        working in /usr1/ldas/lsync-SunOS-sun4u-1.2.36
        running lsync.tcl 21005
        killing lsync.tcl 21005, 21005 /bin/sh ./runner.sh lsync.tcl
        killing lsync.tcl 21006, 21006 tclsh lsync.tcl
        cacheDump errors 
        cacheDump.py errors 
        difference between diskcacheAPI cache and lsync cache
        1,8d0
        < 
        < NOTE: cacheDump assumes that the LDAS runtime is installed
        < under /ldas_outgoing, and will not run if the LDASapi.rsc
        < and LDASdiskcache.rsc are not found!
        < 
        < reading /ldas_outgoing/diskcacheAPI/.frame.cache2
        < this can take a while, please be patient!!
        < DONE!
        child process exited abnormally
        TEST PASSED
         </font></pre>
         
         <p>Examples of failed lsync test:
         <pre><font color='red'>
         working in /usr1/ldas/lsync-SunOS-sun4u-1.2.36
         running lsync.tcl 7175
         killing lsync.tcl 7176,  7176 tclsh lsync.tcl
         killing lsync.tcl 7175,  7175 /bin/sh ./runner.sh lsync.tcl
         cacheDump errors 
         cacheDump.py errors 
         difference between diskcacheAPI cache and lsync cache
        1,8d0
        < 
        < NOTE: cacheDump assumes that the LDAS runtime is installed
        < under /ldas_outgoing, and will not run if the LDASapi.rsc
        < and LDASdiskcache.rsc are not found!
        < 
        < reading /ldas_outgoing/diskcacheAPI/.frame.cache2
        < this can take a while, please be patient!!
        < DONE!
        231c223
        < /scratch/frames/S3_RDS/LHO,H,RDS_R_L1,1,16 1097712130 72 {751800016 751801168}
        ---
        > /scratch/frames/S3_RDS/LHO,H,RDS_R_L1,1,16 1097712093 69 {751800016 751801120}
        233c225
        < /scratch/frames/S3_RDS/LLO,L,RDS_R_L1,1,16 0 121 {751800016 751801952}
        ---
        > /scratch/frames/S3_RDS/LLO,L,RDS_R_L1,1,16 1097712096 116 {751800016 751801872}
        child process exited abnormally
        TEST FAILED
        </font></pre>
        </ul>
       
    </BODY>
</HTML>
